#Script con ejemplo del uso de varias funciones y gráficos útiles para series de tiempo
#Carga un archivo con la cantidad ventas por mes de un negocio
#a diferencia del script1 se hace la diferencia con un lag igual al período
datos = scan("./ventas.dat")

datos = ts(log(datos)) # se configuran los datos como un objeto "time serie" y se le dice la periodicidad de los datos, opcionalmente se le puede indicar la periodicidad de los datos a la función

par(mfrow=c(3,1))        # configura una ventana donde se desplegarán 3 gráficas
plot(datos) #grafica los datos cargados
acf(datos,20) # grafica la función de autocorrelación de los datos hasta un lag de 20
pacf(datos,20) # grafica la autocorrelación parcial hasta un lag de 20 
x11() # crea una nueva ventana para desplegar gráficas
par(mfrow=c(2,1))# configura en la nueva ventana las  2 gráficas a desplegar
dif_datos=diff(datos,lag=1)  # realiza la diferencia de los datos con lag= 1 ( este es el valor por defecto, puede omitirse). Esta operación puede ayudar a "estacionarizar" la serie eliminando tendencias 
plot(dif_datos)# grafica los datos diferenciados
dif12_datos=diff(dif_datos,lag=12) # realiza sobre la diferencia de lag =1 una diferencia de los datos con un lag de 12, esto puede estacionarizar la serie si tiene una periodicidad de 12 unidades de tiempo
plot(dif12_datos)# grafica los datos diferenciados con lag= 1 y lag igual 12


dat=dif12_datos # asigna a la variable dat la variable dif12_datos o dif_datos, o datos, el resto del código trabaja sobre la variable datos por lo que cambiando aquí alguna de las opciones se hacen las operaciones siguientes sobre dif12_datos o dif_datos, o datos

x11() #genera una nueva ventana gráfica
par(mfrow=c(2,1))        # configura dos graficos en la nueva ventana 
hist(datos, prob=TRUE, 100)   # realiza un histograma de los datos    
lines(density(dat))     # suaviza el histograma
qqnorm(dat)             # realiza un gráfico normal Q-Q plot de los datos 
qqline(dat)   		# traza una linea para comparar el QQ plot con el de una dist normal


dat.fit=arima(dat, order=c(1,1,1)) # trata de ajustar con un modelo arima(1,1,1) (observar que vuelve a diferencias d=1 en el modelo si dat ya está diferenciado esto genera una segunda diferenciación)
 
residuo= resid(dat.fit)# esta función me devuelve el residuo de los datos menos el modelo ajustado antes con arima
x11() # crea una nueva ventana 
par(mfrow=c(2,1))        #  configura dos gráficos en la nueva ventana
plot(dat) # dibuja los datos 
plot(residuo) #  y el residuo

x11() # configura una nueva ventana
par(mfrow=c(2,1))        # configura las gráficas 
hist(residuo, prob=TRUE, 100)   # realiza un histograma del residuo    
lines(density(residuo))     # suaviza el histograma  
qqnorm(residuo)             # normal Q-Q plot  del residuo
qqline(residuo)   



