# En este ejemplo se cargan los datos con la cantidad de pasajes mensuales vendidos por una aerolinea
# Se ajustan los datos con un modelos SARIMA(p,d,q) (P,D,Q)12
# se grafica la serie de tiempos y la prediccion
datos = scan("./airline.csv") # se cargan los datos
datos = ts(datos, frequency=12) # se configuran los datos como un objeto "time serie" y se le dice la periodicidad de los datos.
(fit <- arima(datos, c(0, 1, 1),seasonal = list(order=c(0, 1 ,0), period=12)))# el modelo SARIMA, tiene d=1 (diferencia con lag=1 una vez), q= 1 es decir un MA(1), y D=12, es decir que diferencia una vez con lag=12
update(fit, method = "CSS") #se define el método para ajustar los parámetros del modelo
pred <- predict(fit, n.ahead = 24) # con el modelo calculado se realiza una predicción de 24 unidades de tiempo hacia adelante
tl <- pred$pred - pred$se # la prediccion se le resta 
tu <- pred$pred + pred$se
ts.plot(datos,pred$pred, tl, tu, lty = c(1,2,3,4))# se grafican los datos, la prediccion y el intervalo de confianza

