# para este ejemplo es necesario instalar el pakage forecast install.packages(forecast)
#En este ejemplo luego de cargar los datos de la aerolinea
# Se utiliza la funación stl que realiza un filtrado y suavizado de los datos usando el algoritmo de Loess 
# Quien esté interesado en ver en detalle el algoritmo stl puede ver el artículo 
# http://cs.wellesley.edu/~cs315/Papers/stl%20statistical%20model.pdf

#Para el forecasting se le sustrae a los datos la parte no estacional estimada con stl 
# y se utiliza un modelo arima para la predicción de los datos futuros
#http://www.inside-r.org/packages/cran/forecast/docs/forecast.stl
 
library(forecast) #carga la biblioteca forecast

datos = scan("./airline.csv") # se cargan los datos
datos = ts(log(datos), frequency=12) # se configuran los datos como un objeto "time serie" y se le dice la periodicidad de los datos.

plot(modelo <- stl(datos, "per")) #el metodo plot aplicado a un objeto stl grafica los datos, la componente de tendencia, la estacional y el resto
x11() # genera una nueva ventana para graficas
plot(forecast(modelo,h=24,method="arima")) # realiza el forecat de los datos con el modelo stl anterior y usando arima para modelar la parte no estacional.
